# coding: utf-8

module Cryptobox
  # Internalization strings (mapping between short names used in templates
  # and actual internalized text)
  I18N_TEXT = {
    en: {
    title: 'Cryptobox',
    noscript: 'Sorry, this thing heavily depends on JavaScript.',
    locked_title: 'Sign in',
    button_unlock: 'Unlock',
    button_unlock_decrypt: 'Decrypting...',
    form_bookmarklet: 'Cryptobox bookmarklet',
    login_bookmarklet: 'Cryptobox login',
    button_generate: 'Generate password',
    button_lock: 'Lock',
    title_generate: 'Generate password',
    generate_length: 'Length',
    generate_numbers: 'Include numbers',
    generate_punctuation: 'Include punctuation',
    generate_upper_case: 'Include upper case',
    generated: 'Generated password:',
    title_token: 'Enter token',
    created_at: 'created at',
    wait_for_login: 'Logging in, please wait...',
    get_token: 'Get token',
    goto: 'Go to site',
    username: 'Username',
    password: 'Password',
    secret: 'Secret question',
    note: 'Notes',
    incorrect_password: 'Incorrect password!',
    log_in: 'Log in',
    button_back: 'Back',
    login_not_found: 'No logins found!',
    select_login: 'Select login',
    actions: 'Actions',
    filter: 'Filter',
    unmatched_sites: 'Unmatched sites',
    button_details: 'Details',
    address: 'Address',
    button_close: 'Close',
    button_hide_reveal: 'Hide/reveal',
    no_login_with_token: 'Login with token is not supported!',
    button_copy: 'Copy',
    cleared_clipboard: 'Cryptobox has cleared your clipboard!',
    server_not_responding: 'Cryptobox server is not responding!',
    no_websocket_support:  'Your browser does not support WebSockets!',
    hostname: 'Hostname',
    remember_dropbox_credentials: 'Remember Dropbox credentials',
  },
    ru: {
    title: 'Cryptobox',
    noscript: 'Извините, но без JavaScript\'а ничего работать не будет.',
    locked_title: 'Войти',
    button_unlock: 'Разблокировать',
    button_unlock_decrypt: 'Расшифровываю...',
    form_bookmarklet: 'Cryptobox букмарклет',
    login_bookmarklet: 'Cryptobox логин',
    button_generate: 'Создать пароль',
    button_lock: 'Заблокировать',
    title_generate: 'Создать пароль',
    generate_length: 'Длина',
    generate_numbers: 'Включить цифры',
    generate_punctuation: 'Включить знаки пунктуации',
    generate_upper_case: 'Включить символы верхнего регистра',
    generated: 'Пароль:',
    title_token: 'Введите токен',
    created_at: 'создан в',
    wait_for_login: 'Выполняется авторизация, пожалуйста подождите...',
    get_token: 'Получить токен',
    goto: 'Перейти на сайт',
    username: 'Имя пользователя',
    password: 'Пароль',
    secret: 'Секретный вопрос',
    note: 'Заметки',
    incorrect_password: 'Неверный пароль!',
    log_in: 'Войти',
    button_back: 'Назад',
    login_not_found: 'Логин не найден!',
    select_login: 'Выберите логин',
    actions: 'Действия',
    filter: 'Фильтр',
    unmatched_sites: 'Другие сайты',
    button_details: 'Детальная информация',
    address: 'Адрес',
    button_close: 'Закрыть',
    button_hide_reveal: 'Скрыть/показать',
    no_login_with_token: 'Логин с токеном не поддерживается!',
    button_copy: 'Копировать',
    cleared_clipboard: 'Cryptobox очистил буфер обмена!',
    server_not_responding: 'Сервер Cryptobox не отвечает!',
    no_websocket_support:  'Ваш браузер не поддерживает технологию WebSocket!',
    hostname: 'Имя хоста',
    remember_dropbox_credentials: 'Запомнить сессию Dropbox',
  }
  }

  # Internalized page names (mapping between include type and actual
  # internalized page name)
  I18N_PAGE = {
    en: {
    webform: 'Sites',
    card: 'Credit cards',
    note: 'Notes',
    app: 'Applications',
    bookmark: 'Bookmarks',
    account: 'Accounts',
    identity: 'Identities'
  },
    ru: {
    webform: 'Сайты',
    card: 'Кредитные карты',
    note: 'Заметки',
    app: 'Приложения',
    bookmark: 'Закладки',
    account: 'Учетные записи',
    identity: 'Анкетные данные'
  }
  }
end
